#ifndef		__ENGLISTS_HPP
#define		__ENGLISTS_HPP

//File - ENGLISTS.HPP
//***************************************************************************
//
//Description:
//
//    This file contains the class definition for the DPT engine list
//classes.
//
//Copyright Distributed Processing Technology, Corp.
//	  140 Candace Dr.
//	  Maitland, Fl.	32751   USA
//	  Phone: (407) 830-5522  Fax: (407) 260-5366
//	  All Rights Reserved
//
//Author:	Doug Anderson
//Date:		6/29/93
//
//Editors:
//
//Remarks:
//
//
//***************************************************************************


#include	"ptrarray.hpp"
#include	"eng_osd.h"


class	dptCoreDelList_C : public ptrArrayList_C
{
   #include	"del_list.hpp"
};

class	dptRAIDdefList_C : public ptrArrayList_C
{
   #include	"del_list.hpp"
};

class	dptCCBlist_C : public ptrArrayList_C
{
   #include	"del_list.hpp"
};

class	dptIntList_C : public ptrArrayList_C
{
   #include	"del_list.hpp"
};


//Class - dptCoreList_C - start
//===========================================================================
//
//Description:
//
//   This class holds a list of core DPT engine objects and provides
//read only access to the dptList_C class.
//
//Remarks: (Side effects, Assumptions, Warnings...)
//
//---------------------------------------------------------------------------

class	dptCoreList_C : public dptCoreDelList_C
{

// Friends............................................


public:

     // Returns a pointer to an object with the specified tag
   void *		getObject(uLONG);

};
//dptCoreList_C - end


#endif


