//File - DPT_API.C
//***************************************************************************
//
//Description:
//
//      This file contains the function definitions for a real mode
//DOS application to inteface with the DPT engine.
//
//Copyright Distributed Processing Technology, Corp.
//        140 Candace Dr.
//        Maitland, Fl. 32751   USA
//        Phone: (407) 830-5522  Fax: (407) 260-5366
//        All Rights Reserved
//
//Author:       Doug Anderson
//Date:         5/18/94
//
//Editors:
//
//Remarks:
//
//
//***************************************************************************


//Include Files -------------------------------------------------------------

#include        "dpt_api.h"


//Function - DPT_OpenEngine() - start
//===========================================================================
//
//Description:
//
//      This function initializes the DPT engine for use by an
//application.
//
//Parameters:
//
//Return Value:
//
//Global Variables Affected:
//
//Remarks: (Side effects, Assumptions, Warnings...)
//
//
//---------------------------------------------------------------------------

DPT_RTN_T       DPT_OpenEngine()
{

  // Initialize the DPT engine
return (MSG_RTN_COMPLETED);

}
//DPT_OpenEngine() - end


//Function - DPT_CloseEngine() - start
//===========================================================================
//
//Description:
//
//      This function initializes the DPT engine for use by an
//application.
//
//Parameters:
//
//Return Value:
//
//Global Variables Affected:
//
//Remarks: (Side effects, Assumptions, Warnings...)
//
//
//---------------------------------------------------------------------------

DPT_RTN_T       DPT_CloseEngine()
{

  // Initialize the DPT engine
return (MSG_RTN_COMPLETED);

}
//DPT_CloseEngine() - end

#if defined(HAS_COMM_ENG) && defined(NEW_COMM_ENG)   //dz
// Function - DPT_RTN_T	DPT_OpenCommEngine(void) - start
//===========================================================================
//
//Description:  
//
//
//
//Parameters:  
//
//Return Value:  
//
//Global Variables Affected:  
//
//Remarks: (Side effects, Assumptions, Warnings...) 
//
//
//===========================================================================
DPT_RTN_T	DPT_OpenCommEngine(void)
{ 
	return DPTCE_StartUp(NULL);
}
// end - DPT_RTN_T	DPT_OpenCommEngine(void)

// Function - DPT_RTN_T	DPT_CloseCommEngine(void) - start
//===========================================================================
//
//Description:  
//
//
//
//Parameters:  
//
//Return Value:  
//
//Global Variables Affected:  
//
//Remarks: (Side effects, Assumptions, Warnings...) 
//
//
//===========================================================================
DPT_RTN_T	DPT_CloseCommEngine(void)
{ 
	DPTCE_ShutDown();
	return MSG_RTN_COMPLETED;
}
#endif //dz defined(HAS_COMM_ENG) && defined(NEW_COMM_ENG)

// end - DPT_RTN_T	DPT_CloseCommEngine(void)

